searchNodes=[{"ref":"Ink.html","title":"Ink","type":"module","doc":"A backend for the Elixir Logger that logs JSON and filters your secrets. Usage To use Ink for your logging, just configure it as a backend: config :logger, backends: [Ink] # optional additional configuration config :logger, Ink, name: &quot;your app&quot;, level: :info Options In total, the following options are supported by Ink: :name the name of your app that will be added to all logs :io_device the IO device the logs are written to (default: :stdio) :level the minimum log level for outputting messages (default: :debug) :filtered_strings secret strings that should not be printed in logs (default: []) :filtered_uri_credentials URIs that contain credentials for filtering (default: []) :metadata the metadata keys that should be included in the logs (default: all) Filtering secrets Ink can be configured to filter secrets out of your logs: config :logger, Ink, filtered_strings: [&quot;password&quot;] Sometimes, you configure a connection using a URL. For example, a RabbitMQ connection could be configured with the URL &quot;amqp://user:password@localhost:5672&quot;. Filtering the whole URL from your logs doesn&#39;t do you any good. Therefore, Ink has a separate option to pass secret URLs: config :logger, Ink, filtered_uri_credentials: [&quot;amqp://user:password@localhost:5672&quot;] This code will parse the URL and only filter &quot;password&quot; from your logs. Preventing reports on the terminal When processes crash - which is a normal thing to happen in Elixir - OTP sends reports to the handlers of the :error_logger. In some environments, there is a default handler that prints these to the terminal. Since it includes the state of the crashed process, this can include secrets from your application. Ink is unable to filter these reports, because they are not printed using the Logger. You can disable printing of these reports with the following line in your config: config :sasl, sasl_error_logger: false Metadata If you don&#39;t configure any specific metadata, Ink will include all metadata as separate fields in the logged JSON. If you only want to include specific metadata in your logs, you need to configure the included fields. config :logger, Ink, metadata: [:pid, :my_field] Note: Since the term PID is also prevalent in the UNIX world, services like LogStash expect an integer if they encounter a field named pid. Therefore, Ink will log the PID as erlang_pid."},{"ref":"Ink.html#code_change/3","title":"Ink.code_change/3","type":"function","doc":"Callback implementation for c::gen_event.code_change/3."},{"ref":"Ink.html#handle_call/2","title":"Ink.handle_call/2","type":"function","doc":"Callback implementation for c::gen_event.handle_call/2."},{"ref":"Ink.html#handle_event/2","title":"Ink.handle_event/2","type":"function","doc":"Callback implementation for c::gen_event.handle_event/2."},{"ref":"Ink.html#handle_info/2","title":"Ink.handle_info/2","type":"function","doc":"Callback implementation for c::gen_event.handle_info/2."},{"ref":"Ink.html#init/1","title":"Ink.init/1","type":"function","doc":"Callback implementation for c::gen_event.init/1."},{"ref":"Ink.html#terminate/2","title":"Ink.terminate/2","type":"function","doc":"Callback implementation for c::gen_event.terminate/2."},{"ref":"Ink.Encoder.html","title":"Ink.Encoder","type":"module","doc":"Responsible for encoding any value to JSON. Uses Poison for the JSON encoding, but converts values that are not handled by Poison before that, like tuples or PIDs."},{"ref":"Ink.Encoder.html#encode/1","title":"Ink.Encoder.encode/1","type":"function","doc":"Accepts a map and recursively replaces all JSON incompatible values with JSON encodable values. Then converts the map to JSON."},{"ref":"readme.html","title":"Ink","type":"extras","doc":"Ink Ink is a backend for the Elixir Logger with two main purposes: to log JSON documents instead of normal log lines to filter secret strings out of the log lines"},{"ref":"readme.html#installation","title":"Ink - Installation","type":"extras","doc":"Just add :ink to your dependencies and run mix deps.get. def deps do [{:ink, &quot;~&gt; 1.0&quot;}] end"},{"ref":"readme.html#usage","title":"Ink - Usage","type":"extras","doc":"The only thing you have to do is drop some lines into your config. # this will add Ink as the only backend for Logger config :logger, backends: [Ink] # at least configure a name for your app config :logger, Ink, name: &quot;your app&quot; For more information on how to use Ink, take a look at the docs."},{"ref":"readme.html#maintenance","title":"Ink - Maintenance","type":"extras","doc":"get dependencies with mix deps.get execute tests with mix test update dependencies with mix deps.update --all execute tests again mix test"}]